unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FPCanvas, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    FBitmap: TBitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  LRandomColor: Integer;
begin
  if Assigned(FBitmap) then FBitmap.Free;
  LRandomColor := Random($FFFFFF);
  FBitmap := TBitmap.Create;
  FBitmap.SetSize(2, 2);
  FBitmap.Canvas.Pixels[0, 0] := clBlack;
  FBitmap.Canvas.Pixels[0, 1] := LRandomColor;
  FBitmap.Canvas.Pixels[1, 0] := LRandomColor;
  FBitmap.Canvas.Pixels[0, 0] := clBlack;
  Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FBitmap := nil;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FBitmap);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  if not Assigned(FBitmap) then Exit;
  Canvas.Brush.Bitmap := nil;
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Style := bsImage;
  Canvas.Brush.Bitmap := FBitmap;
  Canvas.FillRect(0, 0, ClientWidth, ClientHeight);
end;

end.

